package cz.vutbr.fit.gja.androidTimePicker2;

import java.util.Calendar;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.FragmentActivity;

import android.app.TimePickerDialog;
import android.app.TimePickerDialog.OnTimeSetListener;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.TimePicker;
 
public class MainActivity extends FragmentActivity implements OnTimeSetListener {
 
  private TextView tvDisplayTime;
  private TimePicker timePicker1;
  private Button btnChangeTime;
 
  private int hour;
  private int minute;
 
  static final int TIME_DIALOG_ID = 999;
 
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
 
    setCurrentTimeOnView();
    addListenerOnButton();
 
  }
 
  // display current time
  public void setCurrentTimeOnView() {
 
    tvDisplayTime = (TextView) findViewById(R.id.tvTime);
    timePicker1 = (TimePicker) findViewById(R.id.timePicker1);
 
    final Calendar c = Calendar.getInstance();
    hour = c.get(Calendar.HOUR_OF_DAY);
    minute = c.get(Calendar.MINUTE);
 
    // set current time into textview
    tvDisplayTime.setText(new StringBuilder().append(pad(hour))
                          .append(":").append(pad(minute)));
 
    // set current time into timepicker
    timePicker1.setHour(hour);
    timePicker1.setMinute(minute);
 
  }
 
  public void addListenerOnButton() {
 
    btnChangeTime = (Button) findViewById(R.id.btnChangeTime);
 
    btnChangeTime.setOnClickListener(new OnClickListener() {
 
      @Override
      public void onClick(View v) {

        Bundle b = new Bundle();
        b.putInt(TimePickerDialogFragment.HOUR, hour);
        b.putInt(TimePickerDialogFragment.MINUTE, minute);
        DialogFragment picker = new TimePickerDialogFragment();
        picker.setArguments(b);
        picker.show(getSupportFragmentManager(), "fragment_time_picker");
      }
 
    });
 
  }
 

  @Override
  public void onTimeSet(TimePicker view, int hour, int minute)
  {
    this.hour = hour;
    this.minute = minute;

    tvDisplayTime.setText(new StringBuilder().append(pad(hour))
        .append(":").append(pad(minute)));
  }

  private TimePickerDialog.OnTimeSetListener timePickerListener = 
      new TimePickerDialog.OnTimeSetListener() {
    public void onTimeSet(TimePicker view, int selectedHour,
        int selectedMinute) {
      hour = selectedHour;
      minute = selectedMinute;
 
      // set current time into textview
      tvDisplayTime.setText(new StringBuilder().append(pad(hour))
          .append(":").append(pad(minute)));
 
      // set current time into timepicker
      timePicker1.setHour(hour);
      timePicker1.setMinute(minute);
    }
  };
 
  private static String pad(int c) {
    if (c >= 10) {
      return String.valueOf(c);
    } else {
       return "0" + String.valueOf(c);
    }
  }
}